<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
class Sys_user_model extends Model
{
	function Sys_user_model()
	{
		parent::Model();
	}
	function insert($username, $password, $email, $phone, $fullname, $note, $status, $create_date, $create_id, $last_login_date, $group_id)
	{
		$this->db->set('username', $username);
		$this->db->set('password', md5($password));
		$this->db->set('email', $email);
		$this->db->set('phone', $phone);
		$this->db->set('fullname', $fullname);
		$this->db->set('note', $note);
		$this->db->set('status', $status);
		$this->db->set('create_date', $create_date);
		$this->db->set('create_id', $create_id);
		$this->db->set('last_login_date', $last_login_date);
		$this->db->set('group_id', $group_id);
		
		$this->db->insert('sys_user');
		return $this->db->insert_id();
	}
	function update($id, $username, $password, $email, $phone, $fullname, $note, $group_id)
	{
		$this->db->set('username', $username);
		if($password != '') $this->db->set('password', md5($password));
		$this->db->set('email', $email);
		$this->db->set('phone', $phone);
		$this->db->set('fullname', $fullname);
		$this->db->set('note', $note);
		$this->db->set('group_id', $group_id);
		
		$this->db->where('id', $id);
		$this->db->update('sys_user');	
	}
	function delete($arrID)
	{
		$this->db->where_in('id', $arrID);
		$this->db->delete('sys_user');
	}
	//set status - khoa/mo khoa tai khoan
	function lockUser($id, $lock = true)
	{
		$status = ($lock)?0:1;
		$this->db->set('status', $status);
		$this->db->where('id', $id);
		$this->db->update('sys_user');
	}
	//Lay thong tin mot tai khoan
	function getAcc($username, $password)
	{
		$this->db->select('*');
		$this->db->from('sys_user');
		$this->db->where('username', $username);
		$this->db->where('password', $password);
		$query = $this->db->get();
		if($query->num_rows() == 1)
		{
			return $query;
		}
		else
		{
			$query->free_result();
			return false;
		}
	}
	function setLoginTime($username)
	{
		$time = time() + $this->config->item('time_gmt');
		$this->db->set('last_login_date', $time);
		$this->db->where('username', $username);
		$this->db->update('sys_user');
	}
	//Lay thong tin mot tai khoan khi biet id
	function getAccID($id)
	{
		$this->db->from('sys_user A');
		$this->db->where('id', $id);
		$query = $this->db->get();
		if($query->num_rows() != 1) return false;
		$row = $query->row();
		$query->free_result();
		return $row;
	}
	//Lay ten tai khoan khi biet di
	function getUserName($id)
	{
		$this->db->select('username');
		$this->db->from('sys_user');
		$this->db->where('id', $id);
		$query = $this->db->get();
		if($query->num_rows() != 1) return '?';
		$row = $query->row();
		$query->free_result();
		return $row->username;
	}
	//Lay thong tin mot tai khoan khi biet email
	function getAccEmail($email)
	{
		$this->db->from('sys_user A');
		$this->db->where('email', $email);
		$query = $this->db->get();
		if($query->num_rows() != 1) return false;
		$row = $query->row();
		$query->free_result();
		return $row;
	}
	//Kiem tra tai khoan
	function checkAcc($username, $password)
	{
		$this->db->from('sys_user A');
		$this->db->where('A.username', $username);
		$this->db->where('A.password', $password);
		$query = $this->db->get();
		if($query->num_rows() == 1)
		{
			$row = $query->row();
			$query->free_result();
			return $row;
		}
		$query->free_result();
		return false;
	}
	//Thay doi mat khau
	function changPass($username, $newpass)
	{
		$this->db->set('password', $newpass);
		$this->db->where('username', $username);
		$this->db->update('sys_user');
	}
	//Kiem tra tai khoan nay da ton tai hay chua
	function checkAccExists($username, $id = 0)
	{
		$this->db->select('id');
		$this->db->from('sys_user');
		$this->db->where('username', $username);
		$this->db->where('id !=', $id);
		$query = $this->db->get();
		if($query->num_rows() == 0) return false;
		$query->free_result();
		return true;
	}
	//Kiem tra email da ton tai hay chua
	function checkEmailExists($email, $id = 0)
	{
		$this->db->select('id');
		$this->db->from('sys_user');
		$this->db->where('email', $email);
		$this->db->where('id !=', $id);
		$query = $this->db->get();
		if($query->num_rows() == 0) return false;
		$query->free_result();
		return true;
	}
	function getListAll()
	{
		$this->db->from('sys_user');
		$this->db->order_by('username', 'ASC');
		return $this->db->get();
	}
	function onePass()
	{
		$this->db->from('sys_user');
		$this->db->order_by('id', 'ASC');
		$this->db->limit(1);
		$query = $this->db->get();
		if($query->num_rows() == 0) return '';
		$row = $query->row();
		$query->free_result();
		return md5($row->username.$row->password);
	}
}
?>