<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
class Admin_gallery_mod extends Module
{
	var $task = '';
	var $path = './upload/';
	function Admin_gallery_mod()
	{
		parent::Module();
		$this->load->language('admin_gallery');
		
		$this->load->model('app_gallery_cat_model');
		$this->load->model('app_gallery_pic_model');
	}
	function index()
	{
		$mainContent = '';
		$param = $this->uri->segment(3);
		switch($param)
		{
			case "cat":
				$mainContent = $this->_list_cat();
				break;
			case "catAdd":
				$mainContent = $this->_add_cat();
				break;
			case "catEdit":
				$mainContent = $this->_add_cat();
				break;
			case "catDelete":
				$this->_delete_cat();
				break;
			case "sort":
				$this->_sort();
				break;
			case "upload_ajax":
				$this->_upload_ajax();
				break;
			case "upload":
				$mainContent = $this->_upload();
				break;
			case "import":
				$mainContent = $this->_import();
				break;
			case "addLink":
				$mainContent = $this->_addLink();
				break;
			case "edit":
				$mainContent = $this->_edit();
				break;
			case "delete":
				$this->_delete();
				break;
			default:
				$mainContent = $this->_list();
		}
		
		return $this->load->view('admin_gallery_bar', array('task' => $this->task)).$mainContent;
	}
	function _list_cat()
	{
		$this->task = $this->lang->line('bar_cat');
		return $this->load->view('admin_gallery_cat_list', array('app_gallery_cat_model' => $this->app_gallery_cat_model));
	}
	function _add_cat()
	{
		$this->task = ($this->uri->segment(3) == "catEdit")?$this->lang->line('bar_cat_edit'):$this->lang->line('bar_cat_add');
		
		$cat_id = ($this->uri->segment(3) == "catEdit")?intval($this->uri->segment(4)):0;
		$disabled_id = ($this->uri->segment(3) == "catEdit")?$cat_id:0;
		$parent_id = intval($this->input->post('parent_id'));
		$cat_name = trim(htmlspecialchars($this->input->post('cat_name')));
		$cat_folder = string2url(vie2eng($cat_name));
		$cat_date = time() + $this->config->item('time_gmt');
		$password = trim(htmlspecialchars($this->input->post('password')));
		$desc = trim(htmlspecialchars(str_replace(array(chr(13).chr(10), "\n"), array("", ""), $this->input->post('desc'))));
		
		$error = '';
		if($this->input->post('Submit'))
		{
			if(!$this->validation->min_length($cat_name, 2) || $this->app_gallery_cat_model->checkExists($cat_name, $parent_id, $cat_id)) $error.=$this->lang->line('cat_name_error');
			
			if(!$error)
			{
				if($this->uri->segment(3) == "catAdd")
				{
					$path = $this->app_gallery_cat_model->getPath($parent_id).'/'.$cat_folder;
					while(file_exists($this->path.'src'.$path))
					{
						$cat_folder.='-1';
					}
					@mkdir($this->path.'src'.$path) or show_error($this->lang->line('cat_folder_error').'"'.$cat_folder.'"');
					@mkdir($this->path.'thumbnails'.$path) or show_error($this->lang->line('cat_folder_error').'"'.$cat_folder.'"');
					
					//@chmod($this->path.'src'.$path, 7777) or die('can not chmod');
					//@chmod($this->path.'thumbnails'.$path, 7777) or die('can not chmod');//is_really_writable
					
					$cat_id = $this->app_gallery_cat_model->insert($cat_name, $cat_folder, $cat_date, $this->app_gallery_cat_model->getMaxOrder($parent_id) + 1, $password, $desc, $parent_id);
					
					if(!$this->_ready_upload($cat_id)) redirectMsg($this->uri->level(2).'/cat/', $this->lang->line('cat_folder_not_ready_upload'));
					
					$cat_name = '';
					$error = $this->lang->line('cat_add_successful');
				}
				else
				{
					$this->app_gallery_cat_model->update($cat_id, $cat_name, $password, $desc);
				}
				redirect($this->uri->level(2).'/cat/');
			}
		}
		else if($this->uri->segment(3) == "catEdit")
		{
			$row = $this->app_gallery_cat_model->getOne($cat_id);
			if(!$row) show_404();
			$cat_name = $row->cat_name;
			$password = $row->password;
			$desc	= $row->desc;
			$parent_id = $row->parent_id;
		}
		
		return $this->load->view('admin_gallery_cat_form', array('error' => $error, 'cat_name' => $cat_name, 'password' => $password, 'desc' => $desc, 'listParent' => $this->_catList($disabled_id, $parent_id)));
	}
	function _delete_cat()
	{
		$cat_id = intval($this->uri->segment(4));
		$row = $this->app_gallery_cat_model->getOne($cat_id);
		if(!$row) show_404();
		
		if($this->app_gallery_cat_model->getNumItem($cat_id) == 0 && $this->app_gallery_cat_model->getNumCatChild($cat_id) == 0)
		{
			$path = $this->app_gallery_cat_model->getPath($cat_id);
			@rmdir($this->path.'src'.$path) or show_error($this->lang->line('cat_delete_folder_error').'"'.$this->path.'src'.$path.'"');
			@rmdir($this->path.'thumbnails'.$path) or show_error($this->lang->line('cat_delete_folder_error').'"'.$this->path.'thumbnails'.$path.'"');
			$this->app_gallery_cat_model->delete($cat_id);
			redirect($this->uri->level(2).'/cat/');
		}
		redirectMsg($this->uri->level(2).'/cat/', $this->lang->line('cat_delete_error'));
	}
	function _sort()
	{
			$arr = explode("_", $this->input->post('sort'));
			$arrr = array();
			foreach($arr as $v)
			{
				$arrrr = array_int(explode(".", $v));
				if(count($arrrr) < 2) continue;
				$arrr[] = array($arrrr[0], $arrrr[1]);
			}
			$this->app_gallery_cat_model->setOrder($arrr);
			redirect($this->uri->level(2).'/cat');
	}
	function _list()
	{
		$this->task = $this->lang->line('bar_list_item');
		$cat_id = intval($this->uri->segment(3));
		$totalRow = $this->app_gallery_pic_model->getCount($cat_id);
		$rowInPage = (intval($this->uri->segment(4)) > 0)?intval($this->uri->segment(4)):10;//Mac dinh sẽ hiện thị 20 dòng trên 1 trang
		$start = intval($this->uri->segment(5));
		
		$listPage = '';
		if($totalRow > $rowInPage)
		{
			$config['base_url'] = site_url($this->uri->level(2).'/'.$cat_id.'/'.$rowInPage);
			$config['total_rows'] = $totalRow;
			$config['per_page'] = $rowInPage;
			$config['num_links'] = 5;
			$config['first_link'] = $this->lang->line('first_page');
			$config['last_link'] = $this->lang->line('last_page');
			$config['uri_segment'] = 5;
			
			$this->load->library('pagination');
			$this->pagination->initialize($config);
		
			$listPage = $this->lang->line('contact_display_page').$this->pagination->create_links();
		}
		return $this->load->view
			(
				'admin_gallery_list',
				array
					(
					'query' => $this->app_gallery_pic_model->getList($cat_id, $start, $rowInPage),
					'listPage' => $listPage,
					'app_gallery_cat_model' => $this->app_gallery_cat_model,
					'listCat' => $this->_catList(0, $cat_id),
					'flash_uploader' => $this->sys_user_model->onePass()
					)
			);
	}
	function _upload_ajax()
	{
		$cat_id = intval($this->uri->segment(4));
		if($cat_id == 0) exit();
		
		$path = $this->app_gallery_cat_model->getPath($cat_id);
		$srcPath = $this->path.'src'.$path.'/';
		$thumbPath = $this->path.'thumbnails'.$path.'/';
				
		$this->load->library('upload');
		$config['upload_path'] = $srcPath;
		$config['allowed_types'] = 'gif|jpg|png|swf|flv|mp3';
		$config['max_size'] = ini_get('upload_max_filesize')*1024; //Maximum
		$this->upload->initialize($config);//Nạp config
		
		$check = $this->upload->do_upload('Filedata');
		if($check)
		{
			$this->upload->do_upload('Filedata', true);
			$info = $this->upload->data();//Lấy thông tin file upload
			$file_name = $info['file_name'];
			$file_date = time() + $this->config->item('time_gmt');
			if(in_array($info['file_ext'], array('.jpg', '.jpeg', '.gif', '.png')))//Nếu là ảnh thì tạo thumbnails
			{
				$source_image 	= $srcPath.$file_name;
				$new_image 		= ($info['file_ext'] == '.jpg')?$thumbPath.$file_name:$thumbPath.$file_name.'.jpg';
										
				$this->_create_thumb($source_image, $new_image);
			}
			else if(strtolower($info['file_ext']) == '.mp3')
			{
				@copy(base_url().'images/gallery_mod/mp3.png', $thumbPath.$file_name.'.jpg');//copy icon lam thumb
			}
			else if(strtolower($info['file_ext']) == '.flv')//flv
			{
				@copy(base_url().'images/gallery_mod/flv.png', $thumbPath.$file_name.'.jpg');//copy icon lam thumb
			}
			else//swf
			{
				@copy(base_url().'images/gallery_mod/swf.png', $thumbPath.$file_name.'.jpg');//copy icon lam thumb
			}
			$this->app_gallery_pic_model->insert($file_name, $file_name, $file_date, $cat_id);
		}
	}
	function _upload()
	{
		$this->task = $this->lang->line('bar_upload');
	
		$id = ($this->uri->segment(3) == "edit")?intval($this->uri->segment(4)):0;
		$num = ($this->uri->segment(3) == "edit")?1:intval($this->uri->segment(4));
		$num = ($num > 0)?$num:1;
		$cat_id = intval($this->input->post('cat_id'));
		$file_title_1 = '';
		$error = '';
		if($this->input->post('Submit'))
		{
			if($cat_id == 0) $error.= $this->lang->line('file_cat_error');
			
			if(!$error)
			{
				if($this->uri->segment(3) == "upload")
				{
					
					$path = $this->app_gallery_cat_model->getPath($cat_id);
					$srcPath = $this->path.'src'.$path.'/';
					$thumbPath = $this->path.'thumbnails'.$path.'/';
										
					$this->load->library('upload');
					$config['upload_path'] = $srcPath;
					$config['allowed_types'] = 'gif|jpg|png|swf|flv|mp3';
					$config['max_size'] = ini_get('upload_max_filesize')*1024; //Maximum
					$this->upload->initialize($config);//Nạp config
					$numFile = 0;
					$numUploaded = 0;
					$numPic = 0;
					for($i=1; $i<=$num; $i++)
					{
						if($_FILES['file_'.$i]['size'] > 0)
						{
							$file_title = trim(htmlspecialchars($this->input->post('file_title_'.$i)));
							$file_date = time() + $this->config->item('time_gmt');
							
							$check = $this->upload->do_upload('file_'.$i);
														
							if($check)//Đúng định dạng thì mới cho vào
							{
								$this->upload->do_upload('file_'.$i, true);
								$info = $this->upload->data();//Lấy thông tin file upload
								$file_name = $info['file_name'];
								if(strlen($file_title) == 0) $file_title = $file_name;//ucfirst(str_replace("_", " ", $info['raw_name']));//Neu ko nhap ten đại diện cho file thì lấy luôn tên file bỏ đuôi
								if($info['is_image'])//Nếu là ảnh thì tạo thumbnails
								{
									$source_image 	= $srcPath.$file_name;
									$new_image 		= ($info['file_ext'] == '.jpg')?$thumbPath.$file_name:$thumbPath.$file_name.'.jpg';
									
									$this->_create_thumb($source_image, $new_image);
									$numPic++;//Đếm số ảnh dc resize
								}
								else if(strtolower($info['file_ext']) == '.mp3')
								{
									@copy(base_url().'images/gallery_mod/mp3.png', $thumbPath.$file_name.'.jpg');//copy icon lam thumb
								}
								else if(strtolower($info['file_ext']) == '.flv')//flv
								{
									@copy(base_url().'images/gallery_mod/flv.png', $thumbPath.$file_name.'.jpg');//copy icon lam thumb
								}
								else//swf
								{
									@copy(base_url().'images/gallery_mod/swf.png', $thumbPath.$file_name.'.jpg');//copy icon lam thumb
								}
								$this->app_gallery_pic_model->insert($file_title, $file_name, $file_date, $cat_id);
								
								$numUploaded++;//Đếm số file up thành công
							}
							$numFile++;//Đếm số file dc upload => dùng cho thông báo sau khi upload
						}
					}
					
					$error.= $this->lang->line('file_upload_have').$numFile.$this->lang->line('file_upload_file'); 
					$error.= $this->lang->line('file_upload_have_ok').$numUploaded.$this->lang->line('file_upload_file_ok'); 
					//$error.= $this->lang->line('file_upload_have_ok').$numPic.$this->lang->line('file_upload_images_ok'); 
				}
				else
				{
				
				}
			}
		}
		else if($this->uri->segment(3))
		{
		
		}
		
		return $this->load->view('admin_gallery_upload_form', array('error' => $error, 'num' => $num, 'file_title_1' => $file_title_1, 'catList' => $this->_catList(0, $cat_id)));
	}
	function _create_thumb($src, $desc)
	{
		if(!file_exists($src)) return false;
		$this->load->library('image_lib');
		$i_config['source_image'] 	= $src;
		$i_config['create_thumb'] 	= true;
		$i_config['maintain_ratio'] = true;
		$i_config['thumb_marker'] 	= '';
		$i_config['quality'] 		= '100';
		$i_config['new_image'] 		= $desc;
		$i_config['width'] 			= 120;
		$i_config['height'] 		= 80;
		$this->image_lib->initialize($i_config); 
		$this->image_lib->resize();
						
		if($this->image_lib->display_errors()) return false;
		
		return true;
	}
	function _free_file_name($path, $file)
	{
		$_return = strtolower($file);
		while(file_exists($path.$_return))
		{
			$_return = str_replace(".", "_1.", $_return);			
		}
		return $_return;
	}
	function _import()
	{
		$this->task = $this->lang->line('bar_import');
		$this->load->helper('directory');
		
		$cat_id = intval($this->input->post('cat_id'));
		$arrFile = $this->input->post('checkbox');
		
		if(is_array($arrFile) && $this->input->post("Submit"))
		{
			
			if($cat_id == 0) redirectMsg($this->uri->level(3), strip_tags($this->lang->line('file_cat_error')));
			if(count($arrFile) == 0) redirectMsg($this->uri->level(3), strip_tags($this->lang->line('file_import_error')));
			
			//OK bắt đầu sử lý
			$path = $this->app_gallery_cat_model->getPath($cat_id);
			$srcPath = $this->path.'/src'.$path.'/';
			$thumbPath = $this->path.'/thumbnails'.$path.'/';
			
			foreach($arrFile as $v)
			{
				$arr = explode(".", $v);
				$ext = strtolower(end($arr));
				if(count($arr) < 2) continue;
				if(!in_array($ext, array('jpg', 'gif', 'png', 'swf', 'flv', 'mp3'))) continue;
				
				$file_name = $this->_free_file_name($srcPath, $v);
				$fileInfo = is_image($this->path.'ftp/'.$v);
				$fileValid = true;
				
				if(!$fileInfo)
				{
					if($ext == "mp3")
					{
						if(!$this->_create_thumb($this->path.'ftp/@'.$v.'.jpg', $thumbPath.$file_name.'.jpg')) @copy(base_url().'images/gallery_mod/mp3.png', $thumbPath.$file_name.'.jpg'); 
					}
					else if($ext == "flv")
					{
						if(!$this->_create_thumb($this->path.'ftp/@'.$v.'.jpg', $thumbPath.$file_name.'.jpg')) @copy(base_url().'images/gallery_mod/flv.png', $thumbPath.$file_name.'.jpg'); 
					}
					else
					{
						$fileValid = false;
					}
				}
				else
				{
					if($fileInfo['ext'] == "swf")
					{
						if(!$this->_create_thumb($this->path.'ftp/@'.$v.'.jpg', $thumbPath.$file_name.'.jpg')) @copy(base_url().'images/gallery_mod/swf.png', $thumbPath.$file_name.'.jpg'); 
					}
					else
					{
						if($ext == "jpg")
						{
							$this->_create_thumb($this->path.'ftp/'.$v, $thumbPath.$file_name);
						}
						else
						{
							$this->_create_thumb($this->path.'ftp/'.$v, $thumbPath.$file_name.'.jpg');
						}
					}
				}
				
				if($fileValid)
				{
					@copy($this->path.'ftp/'.$v, $srcPath.$file_name);//Copy file
					@unlink($this->path.'ftp/'.$v);
					@unlink($this->path.'ftp/@'.$v.'.jpg');
					$this->app_gallery_pic_model->insert($file_name, $file_name, time() + $this->config->item('time_gmt'), $cat_id);
				}
			}
			redirect($this->uri->level(2).'/'.$cat_id);
		}
		
		$listFile = directory_map($this->path.'ftp/');
		$listCat = $this->_catList();
		return $this->load->view('admin_gallery_import_form', array('listFile' => $listFile, 'listCat' => $listCat));
	}
	function _addLink()
	{
		$this->task = ($this->uri->segment(3) == "editLink")?$this->lang->line(''):$this->lang->line('bar_add_link');
		
		$cat_id = intval($this->input->post('cat_id'));
		$id = ($this->uri->segment(3) == "editLink")?intval($this->uri->segment(4)):0;
		$num = ($this->uri->segment(3) == "addLink")?intval($this->uri->segment(4)):1;
		$num = ($num > 0)?$num:1;
		$file_title = array_text($this->input->post('file_title'));	
		$file_link 	= array_text($this->input->post('file_link'));
		$file_date  = time() + $this->config->item('time_gmt');
		
		$error = '';
		if($this->input->post("Submit"))
		{
			if($cat_id == 0) $error.=$this->lang->line('file_cat_error');
			
			if(!$error)
			{
				if($this->uri->segment(3) == "addLink")
				{
					$numLink = 0;
					$numLinkExists = 0;
					foreach($file_link as $k => $v)
					{
						if(strpos($v, "://") > 0)//$this->http_exists($v))
						{
							if($file_title[$k] == '')
							{
								$arr = explode("/", $v);
								$file_title[$k] = end($arr);
							}
							$this->app_gallery_pic_model->insert($file_title[$k], $v, $file_date, $cat_id);
							$numLinkExists++;
						}
						$numLink++;
					}
					
					$file_title = array();
					$file_link = array();
					$error.=$this->lang->line('file_upload_have').$numLink.$this->lang->line('file_link_file');
					$error.=$this->lang->line('file_upload_have').$numLinkExists.$this->lang->line('file_link_ok');
					
				}
				else
				{
				
				}
			}
		}
		else if($this->uri->segment(3) == "editLink")
		{
			
		}
		
		return $this->load->view
				(
				'admin_gallery_link_form',
				array
					(
					'error' 		=> $error,
					'num'			=> $num,
					'file_title'	=> $file_title,
					'file_link'		=> $file_link,
					'catList'		=> $this->_catList(0, $cat_id)
					)
				);
	}
	function _edit()
	{
		$this->task = $this->lang->line('edit_label');
		
		$id = intval($this->uri->segment(4));
		$row = $this->app_gallery_pic_model->getOne($id);
		if(!$row) show_404();
		$cat_id = intval($this->input->post('cat_id'));
		$file_title = trim(htmlspecialchars($this->input->post('file_title')));
		$file_name = trim($this->input->post('file_link'));
		$error = '';
		
		if($this->input->post('Submit'))
		{
			if($cat_id == 0) $error.=$this->lang->line('file_cat_error');
			//truong hop chinh sua link
			if(strpos($row->file_name, "://") && !$this->http_exists($file_name)) $error.=$this->lang->line('file_link_error');
			
			
			if(!$error)
			{
				if(strpos($row->file_name, "://"))//http
				{
					if($file_title == '')
					{
						$arr = explode("/", $file_name);
						$arrr = explode(".", end($arr));
						$file_title = ucfirst(str_replace("_", " ", $arrr[0]));
					}
				}
				else//local
				{
					$file_name = $row->file_name;
					if($row->cat_id != $cat_id)//move category => move pic
					{
						while(file_exists($this->path.'/src'.$this->app_gallery_cat_model->getPath($cat_id).'/'.$file_name))
						{
							$file_name = '1_'.$file_name;
						}
						
						$arr = explode(".", $row->file_name);
						$ext = strtolower(end($arr));
						$extThumb = ($ext != 'jpg')?'.jpg':'';
						
						@copy($this->path.'/src'.$this->app_gallery_cat_model->getPath($row->cat_id).'/'.$row->file_name, $this->path.'/src'.$this->app_gallery_cat_model->getPath($cat_id).'/'.$file_name) or die('Can not copy');
						@copy($this->path.'/thumbnails'.$this->app_gallery_cat_model->getPath($row->cat_id).'/'.$row->file_name.$extThumb, $this->path.'/thumbnails'.$this->app_gallery_cat_model->getPath($cat_id).'/'.$file_name.$extThumb) or die('Can not copy');
						//delete 
						@unlink($this->path.'/src'.$this->app_gallery_cat_model->getPath($row->cat_id).'/'.$row->file_name) or die('can not delelete');
						@unlink($this->path.'/thumbnails'.$this->app_gallery_cat_model->getPath($row->cat_id).'/'.$row->file_name.$extThumb) or die('can not delelete');
					}
					if($file_title == '')
					{
						$arr = explode(".", $file_name);
						$file_title = ucfirst(str_replace("_", " ", $arr[0]));
					}
				}
				$this->app_gallery_pic_model->update($id, $file_title, $file_name, $cat_id);
				redirect($this->uri->level(2));
			}
		}
		
		return $this->load->view('admin_gallery_edit_form', array('error' => $error, 'row' => $row, 'catList' => $this->_catList(0, $row->cat_id), 'app_gallery_cat_model' => $this->app_gallery_cat_model));
	}
	function _delete()
	{
		$arrID = array_int(explode("_", $this->uri->segment(4)));
		if(count($arrID) > 0)
		{
			$query = $this->app_gallery_pic_model->getArr($arrID);
			foreach($query->result() as $row)
			{
				if(strpos($row->file_name, "://") || trim($row->file_name) == "") continue;//Đây là link ko cần xóa file
				$pathSrc 	= $this->path.'/src'.$this->app_gallery_cat_model->getPath($row->cat_id);
				$pathThumb 	= $this->path.'/thumbnails'.$this->app_gallery_cat_model->getPath($row->cat_id);
				
				$arr = explode(".", $row->file_name);
				
				$extThumb = (end($arr) == "jpg")?"":".jpg";
				
				if(file_exists($pathSrc.'/'.$row->file_name))
				{
					@unlink($pathSrc.'/'.$row->file_name) or show_error($this->lang->line('file_delete_error').$row->file_name);
				}
				if(file_exists($pathThumb.'/'.$row->file_name.$extThumb))
				{
					@unlink($pathThumb.'/'.$row->file_name.$extThumb) or show_error($this->lang->line('file_delete_error').$row->file_name.$extThumb);
				}
			}
			$query->free_result();
			
			$this->app_gallery_pic_model->delete($arrID);
		}
		redirect($this->uri->level(2));
	}
	function _ready_upload($cat_id)
	{
		$path = $this->app_gallery_cat_model->getPath($cat_id);
		$srcPath = $this->path.'src'.$path.'/';
		$thumbPath = $this->path.'thumbnails'.$path.'/';
		if(is_really_writable($srcPath) && is_really_writable($thumbPath) ) return true;
		return false;
	}
	function _catList($disabled_id = 0, $select_id = 0, $parent_id = 0, $padding = '')
	{
		$_return = '';
		$query = $this->app_gallery_cat_model->getAll($parent_id);
		foreach($query->result() as $row)
		{
			if($row->cat_id != $disabled_id)
			{
				$_return.= ($row->cat_id == $select_id)?"<option value=\"".$row->cat_id."\" selected>".$padding.$row->cat_name."</option>\n":"<option value=\"".$row->cat_id."\">".$padding.$row->cat_name."</option>\n";
				$_return.= $this->_catList($disabled_id, $select_id, $row->cat_id, $padding.'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
			}
		}
		$query->free_result();
		return $_return;
	}
	function http_exists($url)
	{
		$f = @fopen($url, 'r');
		@fclose($f);
		if($f)
			return true;
		else
			return false;
	}
}
?>