<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
class User_gallery_ajax_mod extends Module
{
	function User_gallery_ajax_mod()
	{
		parent::Module();
		$this->load->model('user_gallery_model');
	}
	function index($data)
	{
		switch($this->uri->segment(2))
		{
			case "cat":
				echo $this->loadList();
				break;
			case "new":
				echo $this->loadNew();
				break;
			case "random":
				echo $this->loadRandom();
				break;
			case "detail":
				echo $this->loadDetail();
				break;
			case "search":
				echo $this->search();
				break;
			case "":
				echo $this->home();
				break;
			default:
				redirect($this->uri->level(1));
		}
		exit();
	}
	function home()
	{
		return $this->load->view('user_gallery_ajax_home');
	}
	function loadList()
	{
		$cat_id = intval($this->uri->segment(3));
		$catInfo = $this->user_gallery_model->getCatInfo($cat_id);
		
		$rowInPage = 20;
		$start = intval($this->uri->segment(4));
		
		$numChildCat = $this->user_gallery_model->getNumCatChild($cat_id);
		$numFile = $this->user_gallery_model->getNumFile($cat_id);
		$totalRow = $numChildCat + $numFile;
		
		$cat_query = false;
		$file_query = false;
		$num_cat_query = 0;
		
		if($start <= $numChildCat && $numChildCat > 0)
		{
			$cat_start = $start;
			$cat_query  = $this->user_gallery_model->getFolderChild($cat_id, $cat_start, $rowInPage);
			$num_cat_query = $cat_query->num_rows();
		}
		
		if($num_cat_query < $rowInPage)
		{
				if($num_cat_query > 0)
				{
					$file_start = 0;
				}
				else
				{
					$file_start = $start - $numChildCat;
				}
				$file_end = $rowInPage - $num_cat_query;
				$file_query = $this->user_gallery_model->getPicPage($cat_id, $file_start, $file_end);
		}
		
		$listPage = '';
		if($totalRow > $rowInPage)
		{
			$config['base_url'] = '#cat/'.$cat_id;
			$config['total_rows'] = $totalRow;
			$config['per_page'] = $rowInPage;
			$config['num_links'] = 5;
			$config['first_link'] = '&laquo; First';
			$config['last_link'] = 'Last &raquo;';
			$config['uri_segment'] = 4;
			$config['java_function'] = 'loadList('.$cat_id.', \'{start}\')';
			
			$this->load->library('pagination_ajax');
			$this->pagination_ajax->initialize($config);
		
			$listPage = $this->lang->line('contact_display_page').$this->pagination_ajax->create_links();
		}
		
		//Tao link map
		$linkMap = '<a onclick="loadList(0, 0)" href="#home" title="Home">Home</a>';
		$arr = $this->user_gallery_model->getMap($cat_id);
		if(count($arr) > 0)
		{
			for($i = count($arr) - 1; $i>=0; $i--)
			{
				if($i == 0)
					$linkMap.= ' &raquo; <a class="active" href="#cat/'.$arr[$i]->cat_id.'/'.string2url($arr[$i]->cat_name).'" title="'.$arr[$i]->cat_name.'" onclick="loadList('.$arr[$i]->cat_id.', 0)">'.$arr[$i]->cat_name.'</a>';
				else
					$linkMap.= ' &raquo; <a href="#cat/'.$arr[$i]->cat_id.'/'.string2url($arr[$i]->cat_name).'" title="'.$arr[$i]->cat_name.'" onclick="loadList('.$arr[$i]->cat_id.', 0)">'.$arr[$i]->cat_name.'</a>';
			}
		}
		
		$html = $this->load->view('user_gallery_ajax_list', array('user_gallery_model' => $this->user_gallery_model, 'cat_query' => $cat_query, 'file_query' => $file_query, 'listPage' => $listPage));
		return $this->load->view('user_gallery_ajax_container', array('title' => $linkMap, 'content' => $html));
	}
	function loadNew()
	{
		$html = $this->load->view('user_gallery_ajax_list_file', array('user_gallery_model' => $this->user_gallery_model, 'file_query' => $this->user_gallery_model->getPicNew()));
		return $this->load->view('user_gallery_ajax_container', array('title' => 'New upload', 'content' => $html));
	}
	function loadRandom()
	{
		$html = $this->load->view('user_gallery_ajax_list_file', array('user_gallery_model' => $this->user_gallery_model, 'file_query' => $this->user_gallery_model->getPicRandom()));
		return $this->load->view('user_gallery_ajax_container', array('title' => 'Random', 'content' => $html));
	}
	function loadDetail()
	{
		$id = intval($this->uri->segment(3));
		$row = $this->user_gallery_model->getDetail($id);
		if(!$row) return false;
		
		return $this->load->view('user_gallery_ajax_detail', array('user_gallery_model' => $this->user_gallery_model, 'row' => $row));
	}
	function search()
	{
		$keyword = trim($this->uri->segment(3));
		$start = intval($this->uri->segment(4));
		$rowInPage = 20;
		
		$totalRow = $this->user_gallery_model->searchSum($keyword);
		
		$listPage = '';
		if($totalRow > $rowInPage)
		{
			$config['base_url'] = '#search/'.$keyword.'/';
			$config['total_rows'] = $totalRow;
			$config['per_page'] = $rowInPage;
			$config['num_links'] = 5;
			$config['first_link'] = '&laquo; First';
			$config['last_link'] = 'Last &raquo;';
			$config['uri_segment'] = 4;
			$config['java_function'] = 'loadSearch(\''.$keyword.'\', \'{start}\')';
			
			$this->load->library('pagination_ajax');
			$this->pagination_ajax->initialize($config);
		
			$listPage = $this->lang->line('contact_display_page').$this->pagination_ajax->create_links();
		}
		
		$file_query = $this->user_gallery_model->search($keyword, $rowInPage, $start);
		$linkMap = '<a onclick="loadList(0, 0)" href="#home" title="Home">Home</a> &raquo; Search: <span style="color: white">'.htmlspecialchars($keyword).'</span>';
		
		$html = $this->load->view('user_gallery_ajax_list_file', array('user_gallery_model' => $this->user_gallery_model, 'file_query' => $file_query, 'listPage' => $listPage));
		return $this->load->view('user_gallery_ajax_container', array('title' => $linkMap, 'content' => $html));
	}
}
?>