<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
class App_gallery_cat_model extends Model
{
	function App_gallery_cat_model()
	{
		parent::Model();
	}
	function insert($cat_name, $cat_folder, $cat_date, $cat_order, $password, $desc, $parent_id)
	{

		$this->db->set('cat_name', $cat_name);
		$this->db->set('cat_folder', $cat_folder);
		$this->db->set('cat_date', $cat_date);
		$this->db->set('cat_order', $cat_order);
		$this->db->set('password', $password);
		$this->db->set('desc', $desc);
		$this->db->set('parent_id', $parent_id);
		
		$this->db->insert('app_gallery_cat');
		return $this->db->insert_id();
	}
	function update($cat_id, $cat_name, $password, $desc)
	{
		$this->db->set('cat_name', $cat_name);
		$this->db->set('password', $password);
		$this->db->set('desc', $desc);
		
		$this->db->where('cat_id', $cat_id);
		$this->db->update('app_gallery_cat');	
	}
	function delete($cat_id)
	{
		$row = $this->getOne($cat_id);
		$this->db->where('cat_id', $cat_id);
		$this->db->delete('app_gallery_cat');
		
		$this->reSort($row->parent_id);
	}
	function getOne($cat_id)
	{
		$this->db->from('app_gallery_cat');
		$this->db->where('cat_id', $cat_id);
		$query = $this->db->get();
		if($query->num_rows() == 0) return false;
		$row = $query->row();
		$query->free_result();
		return $row;
	}
	function getAll($parent_id = 0)
	{
		$this->db->from('app_gallery_cat');
		$this->db->where('parent_id', $parent_id);
		$this->db->order_by('cat_order', 'ASC');
		return $this->db->get();
	}
	function getNumItem($cat_id)
	{
		$this->db->from('app_gallery_pic');
		$this->db->where('cat_id', $cat_id);
		return $this->db->count_all_results();
	}
	function getNumCatChild($cat_id)
	{
		$this->db->from('app_gallery_cat');
		$this->db->where('parent_id', $cat_id);
		return $this->db->count_all_results();
	}
	function checkExists($cat_name, $parent_id, $cat_id)
	{
		$this->db->from('app_gallery_cat');
		$this->db->where('cat_name', $cat_name);
		$this->db->where('parent_id', $parent_id);
		$this->db->where('cat_id !=', $cat_id);
		if($this->db->count_all_results() != 0) return true;
		return false; 
	}
	//Đi tìm tổ tiên
	function getPath($cat_id)
	{
		if($cat_id == 0) return '';
		$_return = '';
		$this->db->from('app_gallery_cat');
		$this->db->where('cat_id', $cat_id);
		$query = $this->db->get();
		$row = $query->row();
		$query->free_result();
		$_return.=$this->getPath($row->parent_id).'/'.$row->cat_folder;
		return $_return;
	}

	//Lấy vị trí thấp nhất trong danh sách - phục vụ cho việc chèn dữ liệu mới và sắp xếp
	function getMaxOrder($parent_id)
	{
		$this->db->select("MAX(cat_order) AS 'MaxOrder'");
		$this->db->from('app_gallery_cat');
		$this->db->where('parent_id', $parent_id);
		$query = $this->db->get();
		$row = $query->row();
		$query->free_result();
		return $row->MaxOrder;
	}
	function setOrder($arr)
	{
		foreach($arr as $v)
		{
			$this->db->set('cat_order', $v[1]);
			$this->db->where('cat_id', $v[0]);
			$this->db->update('app_gallery_cat');
		}
		
		$this->reSort();
	}
	function reSort($parent_id = 0)
	{
		$this->db->select('cat_id');
		$this->db->from('app_gallery_cat');
		$this->db->where('parent_id', $parent_id);
		$this->db->order_by('cat_order', 'ASC');
		$query = $this->db->get();
		$i=1;
		foreach($query->result() as $row)
		{
			$this->reSort($row->cat_id);
			
			$this->db->set('cat_order', $i);
			$this->db->where('cat_id', $row->cat_id);
			$this->db->update('app_gallery_cat');
			$i++;
		}
		$query->free_result();
	}
}
?>