<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
class User_gallery_model extends Model
{
	function User_gallery_model()
	{
		parent::Model();
	}
	//Lấy tất cả category có
	function getCatAll()
	{
		$this->db->from('app_gallery_cat');
		$this->db->order_by('cat_order', 'ASC');
		return $this->db->get();
	}
	//Lấy thông tin của 1 categorry
	function getCatInfo($cat_id)
	{
		$this->db->from('app_gallery_cat');
		$this->db->where('cat_id', $cat_id);
		$query = $this->db->get();
		if($query->num_rows() == 0) return false;
		$row = $query->row();
		$query->free_result();
		return $row;
	}
	//Lấy 1 lớp category khi biết parent_id
	function getCat($parent_id = 0)
	{
		$this->db->from('app_gallery_cat');
		$this->db->where('parent_id', $parent_id);
		$this->db->order_by('cat_order', 'ASC');
		return $this->db->get();
	}
	//Lấy tất cả category - trả về 1 mảng
	function getCatChild($cat_id)
	{
		$this->db->select('cat_id');
		$this->db->from('app_gallery_cat');
		$this->db->where('parent_id', $cat_id);
		$query = $this->db->get();
		$_return = array();
		foreach($query->result() as $row)
		{
			array_push($_return, $row->cat_id);
			$_return = array_merge($_return, $this->getCatChild($row->cat_id));
		}
		$query->free_result();
		return $_return;
	}
	//Đếm số thư mục con
	function getNumCatChild($cat_id)
	{
		$this->db->from('app_gallery_cat');
		$this->db->where('parent_id', $cat_id);
		return $this->db->count_all_results();
	}
	//Lấy hết thư mục con - ko lấy cháu chắt
	function getFolderChild($cat_id, $start, $num)
	{
		$this->db->from('app_gallery_cat');
		$this->db->where('parent_id', $cat_id);
		$this->db->limit($num, $start);
		return $this->db->get();
	}
	//Đếm số file có trong 1 thư mục
	function getNumFile($cat_id)
	{
		$this->db->from('app_gallery_pic');
		$this->db->where('cat_id', $cat_id);
		return $this->db->count_all_results();
	}
	//Lấy mảng cat để tạo link map
	function getMap($cat_id)
	{
		$_return = array();
		if($cat_id == 0) return $_return;
		$this->db->from('app_gallery_cat');
		$this->db->where('cat_id', $cat_id);
		$query = $this->db->get();
		if($query->num_rows() == 0) return $_return;
		$row = $query->row();
		$_return[] = $row;
		$_return = array_merge($_return, $this->getMap($row->parent_id));
		$query->free_result();
		return $_return;
	}
	//Đi tìm tổ tiên - lấy path của 1 thư mục
	function getPath($cat_id)
	{
		if($cat_id == 0) return '';
		$_return = '';
		$this->db->from('app_gallery_cat');
		$this->db->where('cat_id', $cat_id);
		$query = $this->db->get();
		$row = $query->row();
		$query->free_result();
		$_return.=$this->getPath($row->parent_id).'/'.$row->cat_folder;
		return $_return;
	}
	//Lấy vài cái mới cập nhật
	function getPicNew($num = 5)
	{
		$this->db->from('app_gallery_pic');
		$this->db->order_by('id', 'DESC');
		$this->db->limit($num);
		return $this->db->get();
	}
	//Lấy vài cái ramdom
	function getPicRandom($num = 5)
	{
		$this->db->from('app_gallery_pic');
		$this->db->order_by('RAND()');
		$this->db->limit($num);
		return $this->db->get();
	}
	//Lấy tất cả ảnh trong 1 thư mục
	function getPic($cat_id)
	{
		$this->db->from('app_gallery_pic');
		$this->db->where('cat_id', $cat_id);
		return $this->db->get();
	}
	//Lấy ảnh của 1 thư mục - có phân trang
	function getPicPage($cat_id, $start, $num)
	{
		$this->db->from('app_gallery_pic');
		$this->db->where('cat_id', $cat_id);
		$this->db->limit($num, $start);
		return $this->db->get();
	}
	//Lấy 1 ảnh đại diện của làm thumb cho 1 thư mục
	function getPicThumb($arrCat)
	{
		$this->db->from('app_gallery_pic');
		$this->db->where_in('cat_id', $arrCat);
		$this->db->limit(1);
		$query = $this->db->get();
		if($query->num_rows() == 0) return false;
		$row = $query->row();
		$query->free_result();
		return $row;
	}
	//Lấy thông tin của 1 record
	function getDetail($id)
	{
		$this->db->from('app_gallery_pic');
		$this->db->where('id', $id);
		$query = $this->db->get();
		if($query->num_rows() == 0) return false;
		$row = $query->row();
		$query->free_result();
		return $row;
	}
	function searchSum($keyword)
	{
		$this->db->from('app_gallery_pic');
		$this->db->like('file_title', $keyword);
		$this->db->or_like('file_name', $keyword);
		return $this->db->count_all_results();
	}
	function search($keyword, $num, $start)
	{
		$this->db->from('app_gallery_pic');
		$this->db->like('file_title', $keyword);
		$this->db->or_like('file_name', $keyword);
		$this->db->order_by('id', 'DESC');
		$this->db->limit($num, $start);
		return $this->db->get();
	}
	//Đếm tất cả hình anh có trong database (jpg, png, gif)
	function countAllImages()
	{
		$this->db->from('app_gallery_pic');
		$this->db->like('file_name', '.jpg', 'before');
		$this->db->or_like('file_name', '.png', 'before');
		$this->db->or_like('file_name', '.gif', 'before');
		return $this->db->count_all_results();
	}
	//Đếm tất cả hình của 1 thể loại
	function catCountAllImages($cat_id)
	{
		$this->db->from('app_gallery_pic');
		$this->db->where("(cat_id = $cat_id)");
		$this->db->like('file_name', '.jpg', 'before');
		$this->db->or_like('file_name', '.png', 'before');
		$this->db->or_like('file_name', '.gif', 'before');
		return $this->db->count_all_results();
	}
	//lấy hình của 1 thể loại nào đó từ start đến num
	function catImages($cat_id, $start, $num)
	{
		$this->db->from('app_gallery_pic');
		if($cat_id > 0) $this->db->where("(cat_id = $cat_id)");
		$this->db->like('file_name', '.jpg', 'before');
		$this->db->or_like('file_name', '.png', 'before');
		$this->db->or_like('file_name', '.gif', 'before');
		$this->db->limit($num, $start);
		return $this->db->get();
	}
}
?>